(* Types *)
type var = string
type term = Var of var | Fun of string * termp list
and termp = term Unionfind.partition
type subst = (var, termp) Hashtbl.t
type unif = termp * termp
(* Creating terms and substitutions *)
val id_subst : unit -> subst
val term_of_varname : var -> termp
val term_of_funname : string -> termp list -> termp
(* Pretty-printing *)
val print_termp : termp -> unit
val print_subst : subst -> unit
(* Unification *)
exception No_unifier
val mgu_cyclic : unif list -> unit
val mgu : unif list -> unit
