open Typedtree

let _ =
  try
    let lexbuf = Lexing.from_channel stdin in
    while true do
      begin
        Format.printf "# ";
        Format.print_flush ();
        try
          let tree = Parse.toplevel lexbuf in
          let typedtree = type_expr tree in
          print_exp_type typedtree;
          Format.print_newline ();
          Format.print_flush ()      
        with 
        | End_of_file ->
          Format.print_newline ();
          Format.print_flush ();
          exit 0
        | x -> Errors.report_error Format.err_formatter x
      end
    done
  with
  | End_of_file -> exit 0
  | x -> Errors.report_error Format.err_formatter x
