(***********************************************************************)
(*                                                                     *)
(*                                OCaml                                *)
(*                                                                     *)
(*            Xavier Leroy, projet Cristal, INRIA Rocquencourt         *)
(*                                                                     *)
(*  Copyright 1996 Institut National de Recherche en Informatique et   *)
(*  en Automatique.  All rights reserved.  This file is distributed    *)
(*  under the terms of the Q Public License version 1.0.               *)
(*                                                                     *)
(***********************************************************************)

(* $Id: typedtree.mli 12681 2012-07-10 08:33:16Z garrigue $ *)

(* Abstract syntax tree after typing *)

open Asttypes
open Parsetree

(* Types *)
type exp_type = Dag.termp

(* Environments *)
type exp_env = Dag.subst

(* Returns the principal type of an expression. *)
val type_expr : expression -> exp_type

(* Prints out a principal type in OCaml style. *)
val print_exp_type : exp_type -> unit

