let _ =
  try
    let lexbuf = Lexing.from_channel stdin in
    while true do
      Format.printf "# ";
      Format.print_flush ();
      begin
        try
          let tree = Parse.toplevel lexbuf in
          Printast.top_phrase Format.std_formatter tree;
          Format.print_newline ();
          Format.print_flush ()      
        with 
        | End_of_file -> 
          Format.print_newline ();
          Format.print_flush ();
          exit 0
        | x -> Errors.report_error Format.err_formatter x
      end
    done
  with
  | End_of_file -> exit 0
  | x -> Errors.report_error Format.err_formatter x
